#!/bin/sh

. /scratchbox/etc/question_func.sh

##############################################################

if [ -f "/scratchbox/.run_me_first_done" ] ; then
	echo "ERROR: This script has already been run..."
	echo "       (/scratchbox/.run_me_first_done -file exists)"
	exit 1
fi

# Mode
mode=`question "Do you want to use sudo mode?" 1 no`
if [ "$mode" = "no" ] ; then
	if [ `id -u` != "0" ] ; then
		echo "ERROR: This has to be run as root."
		exit 1
	fi
else
	if  [ `id -u` = "0" ] ; then
		echo "ERROR: You don't want to do this as root if using sudo mode!"
		exit 1
	fi
fi

# Group name
SB_GROUP=`question "Give the name of the scratchbox group" 2 sbox`

# Create group?
if [ "x`/scratchbox/sbin/getgr $SB_GROUP`" = "x" ] ; then
	echo "The group '$SB_GROUP' does not seem to exist!"
	creategr=`question "Would you like me to create the group '$SB_GROUP' for you?" 1 yes`

	if [ "$creategr" = "yes" ] ; then
		groupadd $SB_GROUP
		if [ "$?" != 0 ] ; then
			echo "ERROR: Creating group..."
			exit 1
		fi
	fi
fi

if [ -L "/scratchbox/scratchbox.config" ] ; then
	rm "/scratchbox/scratchbox.config"
fi
if [ -f "/scratchbox/.sudo_mode" ] ; then
	rm "/scratchbox/.sudo_mode"
fi

# Normal mode!
if [ "$mode" = "no" ] ; then
	for i in `find /scratchbox/ -maxdepth 1 | tr " " "" | grep -ve "^/scratchbox/$" -ve "^/scratchbox/users$" -ve "^/scratchbox/dev$"`; do 
		I=`echo $i | tr "" " "`
		chown -R root.root $I
		chmod -R o-w $I
	done

	chown -R root.$SB_GROUP /scratchbox/sbin/*
	chmod 754 /scratchbox/sbin/*
	chmod u+s /scratchbox/sbin/chroot-uid

	tar -cpf - /dev 2>/dev/null | tar -xpf - -C /scratchbox/

	/scratchbox/sbin/register_arm

	break
fi

# Sudo mode
if [ "$mode" = "yes" ] ; then
	chmod -R a+r /scratchbox/*
	for i in `find /scratchbox/ -type d`; do chmod a+x "$i"; done
	chmod 754 /scratchbox/sbin/*
	mkdir /scratchbox/dev		
	echo "$SB_GROUP" >/scratchbox/.sudo_mode
		
	break		
fi

# Common
mkdir -p /scratchbox/tools/ccache
chgrp $SB_GROUP /scratchbox/tools/ccache
chmod 2775 /scratchbox/tools/ccache

ln -fs /targets/links/scratchbox.config /scratchbox/scratchbox.config
echo "$SB_GROUP" >/scratchbox/.run_me_first_done


echo ""
echo "Scratchbox is now ready.. Now you should add some users! (sbin/sbox_adduser)"
echo ""


